#include <windows.h>
#include <commdlg.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <alloc.h>
#include <ctype.h>
#include <math.h>
#include <shellapi.h>
#include <dos.h>
#include <fcntl.h>
#include <mem.h>
#include <new.h>
#include <setjmp.h>
#include <string.h>
#include <sys/stat.h>
#include <time.h>
#include <dirent.h>
#include <dir.h>
#include "defines.h"
/*-----*/
char*progname=PROGNAME;
typedef uns char byte;
HMENU mainmenu; HWND mwn=0; HINSTANCE Instance=0,PrevInstance=0;
short CmdShow=0;// byte Nn=0;
char tit[1024],title[1024],file[1024]={0},File[1024]={0},rootdir[1024]; byte KEYS[256];
char name[1024],posername[1024]={0,0,0},logname[1024]; FILE*MKM=0,*OBJ=0,*CR2=0;
OPENFILENAME ofn; byte Argc;
/*-----*/
int GetFileName(HWND wn,char*file,char*initdir,char*t,char*f,int write) {int j;
//strcpy(file,tit);
ofn.lStructSize=sizeof(OPENFILENAME); ofn.hwndOwner=wn;
ofn.lpstrFilter=f; ofn.lpstrCustomFilter=0; ofn.nFilterIndex=0;
ofn.lpstrFile=file; ofn.nMaxFile=128;
ofn.lpstrFileTitle=tit; ofn.nMaxFileTitle=256;
ofn.lpstrInitialDir=initdir; ofn.lpstrTitle=t;
ofn.Flags=write?OFN_OVERWRITEPROMPT:OFN_FILEMUSTEXIST;
j=(write?GetSaveFileName(&ofn):GetOpenFileName(&ofn))?1:0; return j;}
/*-----*/
void SetTitle(HWND wn,char*S){SendMessage(wn,WM_SETTEXT,0,(long)S);}
/*-----*/
void GetTitle(HWND wn,char*S,long n){SendMessage(wn,WM_GETTEXT,n,(long)S);}
/*-----*/
char filterall[]="all files\000*.*\000\000";
char filterOBJ[]="OBJ mesh geometry files\000*.OBJ\000\000";
char filterCR2etc[]="files to be checked\000*.CR2;*.PP2;*.PZ3\000\000";
char filterMKM[]="MKM files\000*.MKM\000\000";
typedef struct{char name[64]; byte green,blue,red; double rad;} element;
element elements[128]; int nelements=0; double bondradius=0; byte bondred=128,bondblue=128,bondgreen=128,readxyz=0;
class atom;
class atom{public: atom*parent; char name[32],shortname[16]; element*sort; double theta,phi,bondl;
//double operator-(atom&a);
};
//double atom::operator-(atom&a){return (p-a.p).r();};
atom atoms[1024]; int natoms=0; double pi;
/*-----*/
void DragAccept(HWND wn){DragAcceptFiles(wn,1);}
void DragReject(HWND wn){DragAcceptFiles(wn,0);}
//UINT DragQueryFile(HDROP hdrop,UINT i,char*filename,UNIT fnsize); // returns filename size
short Draghowmanyfiles(HDROP hdrop) {return DragQueryFile(hdrop,-1,0,0);}
//BOOL DragQueryPoint(HDROP hdrop,POINT*lppt); // mouse posn at drop, = nonzero if in client area
//void DragFinish(HDROP hdrop);
/*-----*/
char*parsed[64]; int nargs;
int parse(char*line){int i=0,j,k=0; parsed[0]=0; j=strlen(line); if(j) if(line[j-1]=='\n') line[j-1]=0;
LOOP: while(j=(int(line[k])&0xff),!j?0:j<33?1: j==9/*'\t'*/) line[k++]=0;
if(i>=63?1:!j) goto EXIT; parsed[i++]=line+k;
while(j=line[k],j==' '?0:j=='\t'?0:j) k++; goto LOOP;
EXIT: parsed[i]=0; return i;}
/*-----*/
int argfound(char*s,int k){int i,j; char*t;
for(i=k;t=parsed[i],t;i++) if(!strcmp(s,t)) {for(j=i;j<nargs;j++) parsed[j]=parsed[j+1]; nargs--; return 1;}
return 0;}
/*-----*/
int isgoodname(char*name){int i,j; for(i=0;j=name[i],j;i++) if(!isalnum(j)) if(j!='_') return 0; return 1;}
/*-----*/
int dellocalname(char*file){int i,j; for(j=i=0;file[i];i++) if(file[i]=='\\') j=i; if(j) file[j]=0; return j;}
/*-----*/
int lengthenname(char*f,char*e){char s[5]; int n=strlen(f); if(n<5?1:f[n-4]!='.') return 0;
strcpy(s,f+n-4); strcpy(f+n-4,e); strcat(f,s); return 1;}
/*-----*/
int correctposerfile(char*psfile,char*cor,HWND wn);
FILE*LOG=0; char*repllist=0,pch; long nL;
/*-----*/
void readposerfile(char*orig,HWND wn){
int i,j,k=0,m=0,n=0; char Line[512],line[512],cr2file[512],w[512],cor[512],s[16];
FILE*ORIG=fopen(orig,"r"),*F; if(!ORIG) {MessageBox(0,orig,"I can't open this file",OUCH); return;}
strcpy(Line,posername); cr2file[0]=0; SetTitle(wn,orig);
while(fgets(line,511,ORIG),!feof(ORIG)) {line[511]=0; strcpy(Line,line);
	 i=strlen(line); if(i) if(line[i-1]=='\n') i--; // skip eol
	 while(!i?0:line[i-1]==' '?1:line[i-1]=='\t') i--; line[i]=0; // skip & lose final spaces & tabs, & eol
	 if(i<4?1:strnicmp(&line[i-4],".obj",4)) continue; i--; // check that line is pointer to an .OBJ file
	 for(;i>-0;i--) { // find where an .OBJ file link could start
		  if(i<2?0:!strncmp(line+i-2," :",2)?1:!strncmp(line+i-2,"\t:",2)) break;
		  if(i<4?0:!strncmp(line+i-4,"0 0 ",4)) {m=1; break;} // m==1 == needs attention even if the named .OBJ file exists
		  if(i<14?0:!strncmp(line+i-14,"figureResFile ",4)) {m=1; break;}}
	 strcpy(Line,posername); j=strlen(Line); Line[j++]='\\'; strcpy(Line+j,line+i); k++;
	 for(i=j;Line[i];i++) if(Line[i]==':') Line[i]='\\'; // cure the colitis
	 F=fopen(Line,"r"); if(F) {n++; fclose(F);}}
fclose(ORIG);
if(!m) if(k==n) return;
for(k=0;k<=99;k++) {s[0]='_'; s[1]=s[2]='z'; s[3]='0'+k/10; s[4]='0'+k%10; s[5]=0; strcpy(cor,orig); lengthenname(cor,s);
	 if(F=fopen(cor,"r"),!F) break; else fclose(F);}
if(k>99) return; // no namespace
if(LOG) fprintf(LOG,"file %s being corrected: old version is on\n     %s\n",orig,cor);
j=correctposerfile(orig,cor,wn); // abandoned if j==0
if(j) {strcpy(w,cor); dellocalname(w); strcat(w,"\\MIAOW_EE_EE_SAID_THE_CAT.txt");
	 rename(orig,w); rename(cor,orig); rename(w,cor);} else DeleteFile(cor);
if(LOG) if(!j) fprintf(LOG,"      RUN ABANDONED\n");}
/*-----*/
int correctposerfile(char*orig,char*cor,HWND wn){
int i,j,k,m,v=1; char objfile[512],line[512],oldobj[512]; FILE*ORIG,*COR,*OBJ;
ORIG=fopen(orig,"r"); if(!ORIG) {MessageBox(0,orig,"I can't open this file",OUCH); return 0;}
COR=fopen(cor,"w"); if(!COR) {MessageBox(0,cor,"I can't open this file",OUCH); fclose(ORIG); return 0;}
strcpy(objfile,posername); pch=0;
while(fgets(line,511,ORIG),!feof(ORIG)) {line[511]=0; strcpy(objfile,line); k=0;
	 i=strlen(line); if(i) if(line[i-1]=='\n') i--; // skip eol
	 while(!i?0:line[i-1]==' '?1:line[i-1]=='\t') i--; line[i]=0; // skip & lose final spaces & tabs, & eol
	 if(i<4?1:stricmp(line+i-4,".obj")) {fprintf(COR,"%s\n",line); continue;} // check that line is pointer to an .OBJ file
	 for(;i>0;i--) {
		  if(i<2?0:!strncmp(line+i-2," :",2)?1:!strncmp(line+i-2,"\t:",2)) {k=1; break;}
		  if(i<4?0:!strncmp(line+i-4,"0 0 ",4)) {k=2; break;}
		  if(i<4?0:!strncmp(line+i-14,"figureResFile ",14)) {k=2; break;}}
	 if(!i) {v=0; continue;}
	 strcpy(objfile,posername); j=strlen(objfile); objfile[j++]='\\'; strcpy(objfile+j,line+i); // .OBJ pointer found
	 for(m=j;objfile[m];m++) if(objfile[m]==':') objfile[m]='\\'; strcpy(oldobj,objfile); // cure the colitis
	 OBJ=fopen(objfile,"r"); fclose(OBJ); if(!OBJ) {int l; char id[1024];
		  for(j=0;j<nL;j++) if(!strcmp(objfile,repllist+j*1000)) {strcpy(objfile,repllist+j*1000+500); pch=1; goto LISTED;}
		  strcpy(id,objfile); dellocalname(id);
		  l=GetFileName(wn,objfile,id,"find the correct .OBJ file",filterOBJ,0); if(!l) {v=0; break;} pch=1;
		  if(nL<1000) {strcpy(repllist+nL*1000,oldobj); strcpy(repllist+nL*1000+500,objfile); nL++;}}
LISTED: line[k==1?i-1:i]=0; fprintf(COR,"%s",line);
	 for(m=0;objfile[m];m++) if(objfile[m]=='\\') objfile[m]=':'; // Poser format needs colitis
	 fprintf(COR,"%s\n",objfile+strlen(posername));
	 if(stricmp(oldobj,objfile)) fprintf(LOG,"      pointer to %s replaced by\n      pointer to %s\n",oldobj,objfile);}
fclose(ORIG); fclose(COR); return v;}
/*-----*/
int is_dir(char*path){struct stat i; stat(path,&i); return i.st_mode&S_IFDIR;}
/*-----*/
int isposerfile(char*name){int n=strlen(name)-4; if(n<1) return 0;
if(stricmp(name+n,".pz3"))if(stricmp(name+n,".cr2"))if(stricmp(name+n,".pp2"))if(stricmp(name+n,".hr2")) return 0; return 1;}
/*-----*/
int searchdir(char*dirname,HWND wn){char*name,path[1024],*fns,*dirs; struct dirent*f; int i,j,k,pl,nf,nd;
DIR*dir=opendir(dirname); if(!dir) return IDYES; nf=nd=0;
strcpy(path,dirname); pl=strlen(path); path[pl++]='\\'; path[pl]=0; name=path+pl;
while(f=readdir(dir),f) {strcpy(name,f->d_name); // count relevant entries in dir
	 if(isposerfile(name)) nf++; // relevant Poser files
	 else if(name[0]=='.'?0:is_dir(path)) nd++;} // folders
closedir(dir); if(!(nd+nf)) return IDYES; fns=FM(char,300*(nf+nd+32)); dirs=fns+300*nf+16;
dir=opendir(dirname); j=k=0; if(dir)
while(f=readdir(dir),f) {strcpy(name,f->d_name);  // list file names
	 if(isposerfile(name)) {if(j<nf) strcpy(&fns[(j++)*300],name);}
	 else if(k<nd) if(f->d_name[0]=='.'?0:is_dir(path)) strcpy(&dirs[(k++)*300],name);}
closedir(dir); nf=j; nd=k; // count files in dir
for(i=0;i<nf;i++) {strcpy(path+pl,fns+300*i); readposerfile(path,wn);}
for(i=0;i<nd;i++) {strcpy(path+pl,dirs+300*i); if(!searchdir(path,wn)) break;}
closedir(dir); j=nf?MessageBox(0,dirname,"searchdir finished for this folder: shall I continue?",MB_YESNO):IDYES;
free(fns); return j==IDYES;}
/*-----*/
LRESULT far pascal MainWinProc(HWND wn,UINT iMessage,WPARAM S,LPARAM L){PAINTSTRUCT PS;
WPARAM T; RECT R; long i,j; //HDC dc;
switch(iMessage) {
REP: InvalidateRect(wn,0,1);
default: DEF: return DefWindowProc(wn,iMessage,S,L);
case WM_ENTERIDLE: return 0;
case WM_CREATE: {char Line[512],line[256];
	 for(i=0;i<256;i++) KEYS[i]=0; GetCurrentDirectory(1024,rootdir);
	 SetMenu(wn,mainmenu=LoadMenu(Instance,progname)); ShowWindow(wn,SW_SHOW/*MAXIMIZED*/);
	 DragAcceptFiles(wn,1);
	 strcpy(line,rootdir); strcat(line,"\\chekobjp.ini");
	 GetPrivateProfileString("poserinfo","poseraddr","",posername,256,"poserdirname.ini");
	 if(!*posername) strcpy(posername,"c:"); strcpy(Line,posername); strcpy(line,Line); strcpy(tit,Line);
	 i=MessageBox(0,posername,"Is this the root address of your Poser setup?",MB_YESNO);
	 if(i==IDNO) {
		  strcat(Line,"\\*.*");
		  i=GetFileName(wn,Line,line,"find any file in your Poser installation's root folder",filterall,0);
		  strcpy(posername,Line);
		  if(!i) {MessageBox(wn,"I need this information to be able to run.","Exiting",OUCH); goto WHOA;}
		  i=dellocalname(posername);
		  if(!i) {MessageBox(wn,posername,"This is not a valid file name. Exiting",OUCH); goto WHOA;}
		  MessageBox(0,posername,"You say that your Poser installation is at",MB_OK);
		  WritePrivateProfileString("poserinfo","poseraddr",posername,"poserdirname.ini");}
//MessageBox(wn,posername,"end of _CREATE_: posername =",OUCH);
	 goto DEF;}
case WM_CLOSE: goto DEF;
case WM_QUIT: goto DEF;
case WM_DESTROY: WHOA: PostQuitMessage(0); return 0;
case WM_GETMINMAXINFO: {MINMAXINFO*p=(MINMAXINFO*)L; p->ptMaxPosition.x=p->ptMaxPosition.y=-4; return 0;}
case WM_PAINT: {GetClientRect(wn,&R); BeginPaint(wn,&PS); EndPaint(wn,&PS);
	 if(Argc>1) {Argc=0; strcpy(file,_argv[1]); goto AUTOREAD;} goto DEF;}

#if 0
case WM_KEYDOWN: case WM_SYSKEYDOWN: case WM_KEYUP: case WM_SYSKEYUP: {
	 byte W=(byte)(S&0xff); double w,deg=atan(1)/45,c,s;
	 int rep=(short)(L&0xffff),/* scan=(short)((L>>16)&0xff),*/ /*ext=(short)((L>>24)&1),*/
	 /*alt=(short)((L>>29)&1),*/ up=iMessage&1, rel=(short)((L>>31)&1); //uns long G;
	 KEYS[W]=rel?0:0xff;}
#endif

case WM_DROPFILES: i=Draghowmanyfiles(HDROP(S));
		 if(i!=1) {MessageBox(wn,"one file at a time please","drag-and-drop",OUCH); DragFinish(HDROP(S)); break;}
	 DragQueryFile(HDROP(S),0,file,256); strcpy(tit,file); DragFinish(HDROP(S));
	 if(is_dir(file)) goto AUTOREADDIR;
	 if(isposerfile(file)) goto AUTOREAD;
	 MessageBox(0,file,"I can't handle this sort of file",OUCH); break;

case WM_COMMAND: T=S; goto MENU;}
MENU: switch((unsigned short)T) {default: goto DEF;

case _READFILE_: if(!GetFileName(wn,file,posername,"file to check?",filterCR2etc,0)) goto DEF;
AUTOREAD: {
	 strcpy(logname,rootdir); strcat(logname,"\\"); strcat(logname,"__result_of_run.txt");
	 LOG=fopen(logname,"w"); if(!repllist) {repllist=FM(char,1000000); nL=0;}
	 fprintf(LOG,"no alterations\n"); rewind(LOG); readposerfile(file,wn); fclose(LOG);
//	 LOG=fopen(logname,"r"); repllist[0]=0; fread(repllist,1,100000,LOG); MessageBox(0,repllist,"finished",MB_OK); fclose(LOG);
	 goto TIDYUP;}

case _READDIR_: if(!GetFileName(wn,file,posername,"find any file in the folder to be checked",filterall,1)) goto DEF;
	 if(!is_dir(file)) {j=dellocalname(file); if(!j) {MessageBox(0,file,"this is not a valid filename",OUCH); goto DEF;}}
AUTOREADDIR: {
	 strcpy(logname,rootdir); strcat(logname,"\\"); strcat(logname,"__result_of_run.txt"); //strcpy(file,"zxcvbnm.zxcvbnm");
	 if(!repllist) {repllist=FM(char,1000000); nL=0;} LOG=fopen(logname,"w"); searchdir(file,wn); fclose(LOG);
	 MessageBox(0,logname,"searchdir finished, my log is on this file",MB_OK);
TIDYUP: strcpy(name,logname); j=dellocalname(name); strcpy(file,name+j+1);
	 if(MessageBox(0,logname/*"(This will let you save the log on another file)"*/,"do you want to see my log for this run?",MB_YESNO)
		==IDYES) ShellExecute(wn,"open","NOTEPAD",logname,"",SW_SHOW);
	 goto DEF;}
case _HELP_: MessageBox(0,"For information, read the file chekobjp_readme.txt that came with this application.","",MB_OK);
	 goto DEF;
case _EXIT_: EXIT2: if(repllist) free(repllist); repllist=0;  SendMessage(wn,WM_CLOSE,0,0); goto DEF;}}
/*-----*/
static void Register(char*name,WNDPROC proc) {WNDCLASS c;
c.style=CS_HREDRAW|CS_VREDRAW|CS_SAVEBITS; c.lpfnWndProc=proc; c.cbClsExtra=0;
c.cbWndExtra=2; c.hInstance=Instance; c.hIcon=LoadIcon(Instance,progname);
c.hCursor=LoadCursor(0,IDC_ARROW); c.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
c.lpszMenuName=0; c.lpszClassName=name; if(!RegisterClass(&c)) exit(0);}
/*-----*/
HWND newwindow(char*clas,char*name,long c=0){
HWND w=CreateWindow(clas,name,WS_OVERLAPPEDWINDOW|c,
	 CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,0,0,Instance,0);
	 if(w) {ShowWindow(w,SW_SHOW); UpdateWindow(w);} return w;}
/*-----*/
// Turn off warning: Parameter 'CmdLine' is never used in function WinMain(unsigned int,unsigned int,char far*,int)
#pragma argsused
// Turn off warning: 'MainWnd' is assigned a value that is never used in function WinMain(unsigned int,unsigned int,char far*,int)
#pragma option -w-aus
/*-----*/
int PASCAL WinMain(HINSTANCE hInst,HINSTANCE hPrev,LPSTR CmdLine,int nCmdShow){
MSG msg; Instance=hInst; PrevInstance=hPrev; CmdShow=(short)nCmdShow;
if(!hPrev) Register(progname,MainWinProc);
//manipulate(".pz3"); strcpy(posername,strang);
mwn=newwindow(progname,progname,/*WS_HSCROLL|WS_VSCROLL|*/WS_MAXIMIZE); if(!mwn) exit(0);
/*posername[0]=0;*/ pi=4*atan(1.); GetCurrentDirectory(256,rootdir);
while(GetMessage(&msg,0,0,0)) {TranslateMessage(&msg); DispatchMessage(&msg);}
return msg.wParam;}

